class M_Arena expands Mutator config (M_Arena);

var bool bPreInit, bPostInit;
var const string version;
var MonsterHuntArena MA;

var config bool bCheckBossLink;

event PreBeginPlay()
{
	if (!bPreInit)
	{
		log ("Monster Arena mutator version"@version@"initializing...");
		DoGameSetup();
		bPreInit = True;
	}
	else
	{
		log (Self.Name@"has been already called::PreBeginPlay::Rejecting new call.");
	}
}

event PostBeginPlay()
{
	if (!bPostInit)
	{
		bPostInit = True;
	}
	else
	{
		log (Self.Name@"has been already called::PostBeginPlay::Rejecting new call.");
	}
}

function DoGameSetup()
{
	if ( MonsterHuntArena(Level.Game) != None )
	{
		MA = MonsterHuntArena(Level.Game);
		log (Self.Name@"has found MonsterHuntArena game-type running. Proceed operations...");
	}
	else
	{
		log (Self.Name@"did not find a valid MonsterHuntArena game-type. Intializing self corrodation...");
		LifeSpan=10.000000;
	}
	if ( MA != None )
	{
// Simple stupid fix
		if ( MA.GameReplicationInfoClass != Class'MonsterHunt.MonsterReplicationInfo' )
		{
			MA.Default.GameReplicationInfoClass=Class'MonsterHunt.MonsterReplicationInfo';
			MA.GameReplicationInfoClass=Class'MonsterHunt.MonsterReplicationInfo';
		}
		if (bCheckBossLink)
			DoCheckBoss();
	}
}

function DoCheckBoss()
{
	local MonsterArenaEnd ME;
	local ScriptedPawn S;
	local bool bLinkedWell, bHaveEnd;
	local int NumDumbEnd;

	foreach AllActors(class 'ScriptedPawn',S)
	{
		if ( S.Event != '' )
		{
			foreach AllActors(class'MonsterArenaEnd',ME,S.Event)
			{
				Log (S.Name@"seems the game goal correctly set.");
				bLinkedWell=True;
				break;
			}
		}
	}
	if (!bLinkedWell)
	{
		foreach AllActors (class'MonsterArenaEnd',ME)
		{
			bHaveEnd=True;
			NumDumbEnd++;
		}
	}
	if ( bHaveEnd )
	{
		if ( NumDumbEnd > 1 )
			log ("We have"@NumDumbEnd@" Ends but no monster seems to link it.");
		else
			log ("End do not seems linked with nothing at this moment.");
	}
	if ( !bLinkedWell && !bHaveEnd )
	{
		log ("This map must be checked if ends correctly...");
	}
}

defaultproperties
{
   version="1.00"
}